/*
TASK: cube
LANG: C++
*/
#include <iostream>
#include <queue>
#include <iomanip>
using namespace std;
struct pos{
    int x, y;
};
struct cub{
    int left, right, up, down, front, back, dist;
};
cub c, cube[128][128];
int a[128][128], used[128][128], dist[128][128], sused[128][128], path[128][128];
pos s, f, last[128][128],p[4];
void scan(){
    string t1, t2;
    cin >> t1 >> t2;
    s.x = 8 - (t1[1] - '0');
    s.y = t1[0] - 'a';
    f.x = 8 - (t2[1] - '0');
    f.y = t2[0] - 'a';
    cin >> c.front >> c.back >> c.up >> c.right >> c.down >> c.left;
    int t;
    cin >> t;
    for ( int i = 0; i < t; ++i ){
        cin >> t1;
        a[8 - (t1[1] - '0')][t1[0] - 'a'] = 1;
    }
}
void bfs(int i, int j){
    pos t;
    queue <pos> q;
    t.x = i;
    t.y = j;
    q.push(t);
    used[i][j] = 1;
    last[i][j].x = i;
    last[i][j].y = j;
    while ( !q.empty() ){
        t = q.front();
        q.pop();
        i = t.x; j = t.y;
        for ( int k = 0; k < 4; ++k )
            if ( i + p[k].x < 8 && i + p[k].x >= 0 && j + p[k].y < 8 && j + p[k].y >= 0 )
                if ( !used[i + p[k].x][j + p[k].y] && !a[i + p[k].x][j + p[k].y]){
                    t.x = i + p[k].x;
                    t.y = j + p[k].y;
                    used[t.x][t.y] = used[i][j] + 1;
                    last[t.x][t.y].x = i;
                    last[t.x][t.y].y = j;
                    q.push(t);
                }
    }
}
cub ru(cub t){
    cub ans;
    ans = t;
    ans.down = t.back;
    ans.back = t.up;
    ans.up = t.front;
    ans.front = t.down;
    return ans;
}
cub rd(cub t){
    cub ans;
    ans = t;
    ans.down = t.front;
    ans.back = t.down;
    ans.up = t.back;
    ans.front = t.up;
    return ans;
}
cub rl(cub t){
    cub ans;
    ans = t;
    ans.left = t.up;
    ans.down =t.left;
    ans.right = t.down;
    ans.up = t.right;
    return ans;
}
cub rr(cub t){
    cub ans;
    ans = t;
    ans.left = t.down;
    ans.down =t.right;
    ans.right = t.up;
    ans.up = t.left;
    return ans;
}
void minpaths(int i, int j){
    pos t;
    queue <pos> q;
    cube[i][j] = c;
    t.x = i;
    t.y = j;
    path[i][j] = c.down;
    sused[i][j] = 1;//cout << cube[i][j].front << cube[i][j].back << cube[i][j].left <<  cube[i][j].right << cube[i][j].up << cube[i][j].down<< endl;
    for ( int k = 0; k < 4; ++k)
        if ( i + p[k].x < 8 && i + p[k].x >= 0 && j + p[k].y < 8 && j + p[k].y >= 0 )
            if ( !sused[i + p[k].x][j + p[k].y] && !a[i + p[k].x][j + p[k].y]){
                t.x = i + p[k].x;
                t.y = j + p[k].y;
                sused[t.x][t.y] = 1;
                q.push(t);
            }
    while ( !q.empty()){
        t = q.front();
        q.pop();
        i = t.x; j = t.y;
        for ( int k = 0; k < 4; ++k )
            if ( i + p[k].x < 8 && i + p[k].x >= 0 && j + p[k].y < 8 && j + p[k].y >= 0 )
                if ( used[i + p[k].x][j + p[k].y] == used[i][j] - 1 ){
                    int min = ( 1 << 20 );
                    if ( p[k].x == -1 && p[k].y == 0 &&
                     path[p[k].x + i][p[k].y + j] + cube[p[k].x + i][p[k].y + j].front < min){
                        cube[i][j] = rd(cube[i + p[k].x][j + p[k].y]);
                        min = path[p[k].x + i][p[k].y + j] + cube[p[k].x + i][p[k].y + j].front;
                        path[i][j] = min;
                    }
                    if ( p[k].x == 0 && p[k].y == -1 &&
                     path[p[k].x + i][p[k].y + j] + cube[p[k].x + i][p[k].y + j].right < min){
                        cube[i][j] = rr(cube[i + p[k].x][j + p[k].y]);
                        min = path[p[k].x + i][p[k].y + j] + cube[p[k].x + i][p[k].y + j].right;
                        path[i][j] = min;
                    }
                    if ( p[k].x == 1 && p[k].y == 0 &&
                     path[p[k].x + i][p[k].y + j] + cube[p[k].x + i][p[k].y + j].back < min){
                        cube[i][j] = ru(cube[i + p[k].x][j + p[k].y]);
                        min = path[p[k].x + i][p[k].y + j] + cube[p[k].x + i][p[k].y + j].back;
                        path[i][j] = min;
                    }
                    if ( p[k].x == 0 && p[k].y == 1 &&
                     path[p[k].x + i][p[k].y + j] + cube[p[k].x + i][p[k].y + j].left < min){
                        cube[i][j] = rl(cube[i + p[k].x][j + p[k].y]);
                        min = path[p[k].x + i][p[k].y + j] + cube[p[k].x + i][p[k].y + j].left;
                        path[i][j] = min;
                    }
                }//cout << cube[i][j].front << cube[i][j].back << cube[i][j].left <<  cube[i][j].right << cube[i][j].up << cube[i][j].down<< endl;
        for ( int k = 0; k < 4; ++k)
        if ( i + p[k].x < 8 && i + p[k].x >= 0 && j + p[k].y < 8 && j + p[k].y >= 0 )
            if ( !sused[i + p[k].x][j + p[k].y] && !a[i + p[k].x][j + p[k].y]){
                t.x = i + p[k].x;
                t.y = j + p[k].y;
                sused[t.x][t.y] = 1;
                q.push(t);
            }
    }
}                  
void solve(){
    p[2].x = p[1].y = 1;
    p[0].x = p[3].y = -1;
    bfs(s.x, s.y);
    minpaths(s.x, s.y);
    cout << path[f.x][f.y] << endl;
 //   for ( int i = 0; i < 8; ++i ){
 //    //   for ( int j = 0; j < 8; ++j )
      //      cout << setw(10) << path[i][j] << " ";
 //       cout << endl;
  //  }
  //  for ( int i = 0; i < 8; ++i ){
   //     for ( int j = 0; j < 8; ++j )
        //    cout << setw(10) << used[i][j] << " ";
    //    cout << endl;
    //cout << path[f.x][f.y] << endl;}
}
int main(){
    scan();
    solve();
}
